Option Explicit On 
Option Strict On
Option Compare Binary

Imports System.Windows.Forms

' <remarks>
'   Erweitert das Standard-RichTextBox-Steuerelement 
'   um ein Kontextmen, das Standardfunktionen enthlt.
' </remarks>
Public Class ExtendedRichTextBox
    Inherits RichTextBox

    Private WithEvents m_mnuCopy As New MenuItem()
    Private WithEvents m_mnuPaste As New MenuItem()
    Private WithEvents m_mnuCut As New MenuItem()
    Private WithEvents m_mnuDelete As New MenuItem()
    Private WithEvents m_mnuSelectAll As New MenuItem()

    ' <summary>
    '   Erstellt eine neue Instanz der Klasse.
    ' </summary>
    Public Sub New()
        MyBase.New()
        With m_mnuCopy
            .Index = 1
            .Shortcut = Shortcut.CtrlC
            .ShowShortcut = True
            .Text = "&Kopieren"
        End With
        With m_mnuPaste
            .Index = 2
            .Shortcut = Shortcut.CtrlP
            .ShowShortcut = True
            .Text = "&Einfgen"
        End With
        With m_mnuCut
            .Index = 3
            .Shortcut = Shortcut.CtrlX
            .ShowShortcut = True
            .Text = "&Ausschneiden"
        End With
        With m_mnuDelete
            .Index = 4
            .Shortcut = Shortcut.Del
            .ShowShortcut = True
            .Text = "&Lschen"
        End With
        With m_mnuSelectAll
            .Index = 5
            .Shortcut = Shortcut.CtrlA
            .ShowShortcut = True
            .Text = "Alles a&uswhlen"
        End With
        Me.ContextMenu = New ContextMenu( _
            New MenuItem() { _
                m_mnuCopy, _
                m_mnuPaste, _
                m_mnuDelete, _
                m_mnuCut, _
                m_mnuSelectAll _
            } _
        )
    End Sub

    Protected Overloads Overrides Sub Dispose( _
      ByVal disposing As Boolean)
        MyBase.Dispose(disposing)
    End Sub

    Private Sub m_mnuCopy_Click( _
      ByVal sender As System.Object, _
      ByVal e As System.EventArgs) _
      Handles m_mnuCopy.Click
        Clipboard.SetDataObject( _
          New DataObject(DataFormats.Rtf, Me.SelectedRtf))
    End Sub

    Private Sub m_mnuPaste_Click( _
      ByVal sender As System.Object, _
      ByVal e As System.EventArgs) _
      Handles m_mnuPaste.Click
        Me.SelectedRtf = _
        CStr(Clipboard.GetDataObject().GetData(DataFormats.Rtf, True))
    End Sub

    Private Sub m_mnuCut_Click( _
      ByVal sender As System.Object, _
      ByVal e As System.EventArgs) _
      Handles m_mnuCut.Click
        Clipboard.SetDataObject(New _
          DataObject(DataFormats.Rtf, Me.SelectedRtf))
        Me.SelectedText = ""
    End Sub

    Private Sub m_mnuDelete_Click( _
      ByVal sender As System.Object, _
      ByVal e As System.EventArgs) _
      Handles m_mnuDelete.Click
        Me.SelectedText = ""
    End Sub

    Private Sub m_mnuSelectAll_Click( _
      ByVal sender As System.Object, _
      ByVal e As System.EventArgs) _
      Handles m_mnuSelectAll.Click
        Me.SelectAll()
    End Sub
End Class